<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Dokumente\DokumenteUpload;

abstract class DokumenteUploadController extends \Kufer\Web\KuferTools\Basis\Controller\AjaxNoContainerToolController
{
  protected function getNewRequestObj(): DokumenteUploadRequest
  {
    return new DokumenteUploadRequest();
  }

  protected function getRequestObj()
  {
    $requestObj = $this->getNewRequestObj();
    $requestObj->bezeichnung = \PostOperations::getVarValue('detail_bezeichnung_dokumente');
    $requestObj->file = isset($_FILES['detail_original_dokumente']) ? $_FILES['detail_original_dokumente'] : '';
    $requestObj->allowFirmen = \PostOperations::isDefined('allow_firmen');
    $requestObj->allowTeilnehmer = \PostOperations::isDefined('allow_teilnehmer');

    $requestObj = $this->handleXsrf($requestObj, 'dokumenteUpload');

    return $requestObj;
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    $statusMessageContainer = new \Kufer\Web\KuferTools\Utils\StatusMessages\StatusMessageContainer();
    $statusMessageContainer->addStatusMessageByOldObject($pUseCaseResponse->statusCodeAndMessage);

    return new \Kufer\Web\KuferTools\Dozent\KursUebersicht\KursDetails\KursDetailsExternController($pUseCaseResponse->kurs->id, $statusMessageContainer);
  }
}